/*
*******************************************************************************
**
**  This device driver was created by Applilet2 for 78K0/Kx2
**  8-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002 - 2008
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	main.c
**  Abstract :	This file implements main function.
**  APIlib :	Applilet2 for 78K0/Kx2 V2.10 [6 Mar. 2007]
**
**  Device :	uPD78F0515_48
**
**  Compiler :	CC78K0
**
**  Creation date:	2008/04/20
**  
*******************************************************************************
*/

/*
*******************************************************************************
** Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "System.h"
#include "Port.h"
#include "Timer.h"
/* Start user code for include definition. Do not edit comment generated here */
/* End user code for include definition. Do not edit comment generated here */
#include "user_define.h"

/*
*******************************************************************************
**  Global define
*******************************************************************************
*/
/* Start user code for global definition. Do not edit comment generated here */
/* End user code for global definition. Do not edit comment generated here */


/*
**-----------------------------------------------------------------------------
**
**  Abstract:
**	This function implements main function.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**-----------------------------------------------------------------------------
*/
unsigned int	khz_no;
unsigned int	out_volt_data;
unsigned int	test_tun_data;
unsigned int	led_count;
unsigned char	preset_no;
unsigned int	over;
unsigned long	sokutei;
unsigned long	f_sokutei;

const unsigned int	d[150]={
	3000,3250,3925,3945,3955,3985,4000,4190,4220,4330,
	4460,4620,4750,4785,4800,4820,4840,4905,4920,4940,
	4950,4960,4965,4975,5030,5040,5050,5240,5420,5850,
	5860,5900,5905,5910,5915,5920,5925,5930,5935,5940,
	5945,5950,5955,5960,5965,5970,5975,5980,5985,5990,
	6010,6015,6020,6030,6035,6040,6045,6050,6055,6060,
	6065,6070,6075,6080,6085,6090,6100,6105,6110,6115,
	6120,6125,6130,6135,6140,6145,6150,6155,6160,6165,
	6175,6180,6185,6190,6195,6200,7105,7110,7115,7120,
	7125,7130,7140,7150,7155,7160,7165,7170,7175,7180,
	7185,7190,7195,7200,7205,7210,7215,7220,7225,7230,
	7235,7240,7245,7250,7255,7260,7265,7270,7275,7280,
	7285,7290,7295,7300,7305,7315,7325,7330,7335,7340,
	7350,7360,7365,7375,7390,7400,7405,7430,7445,7455,
	7470,7480,7510,7520,7555,7580,7595,7620,7935,8200
	};


void	init_data(void)
{
	khz_no=3000;
	out_volt_data=0;
	
	P7.3=0;P7.4=0;P7.5=0;
	P12.0=0;P12.1=0;
}

void	wait_time(unsigned int time)
{
	while(time!=0){
		time--;
	}
}

/*----------  LED MODULE ----------*/
void	led_clear(void)
{
	P2.0=1;P2.1=1;P2.2=1;P2.3=1;P2.4=1;P2.5=1;P2.6=1;
	P3.0=1;
}
void	led_khz(unsigned int hz)
{
unsigned char n0,n1,n2,n3;
unsigned int count;
unsigned int nn;

	count=hz;
	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);count=(count-n2)/10;
	n3=(unsigned char)(count%10);

	led_clear();
	
	switch(n3){
		case 3:P2.6=0;break;
		case 4:P2.5=0;break;
		case 5:P2.4=0;break;
		case 6:P2.3=0;break;
		case 7:P2.2=0;break;
		case 8:P2.1=0;break;
		case 9:P2.0=0;break;
	}
	
	led_count=5000;
}

/*---------- VOLTAGE  ----------*/
void	dac_out_ch1(unsigned int data)
{
unsigned int 	d0;
unsigned char	d1;
unsigned char	i;

	P7.3=0;
	P7.4=1;
	d0=data << 4;
	d1=0x20;
	P7.4=0;
	
	for(i=0;i<8;i++){
		if((d1 & 0x80)==0x80){
			P7.5=1;
		}
		else{
			P7.5=0;
		}
		P7.3=1;
		d1=d1 << 1;
		P7.3=0;
	}
	
	for(i=0;i<16;i++){
		if((d0 & 0x8000)==0x8000){
			P7.5=1;
		}
		else{
			P7.5=0;
		}
		P7.3=1;
		d0=d0 << 1;
		P7.3=0;
	}
	P7.4=1;
	P7.5=0;
}
void	dac_out_ch2(unsigned int data)
{
unsigned int 	d0;
unsigned char	d1;
unsigned char	i;

	P7.3=0;
	P7.4=1;
	d0=data << 4;
	d1=0x21;
	P7.4=0;
	
	for(i=0;i<8;i++){
		if((d1 & 0x80)==0x80){
			P7.5=1;
		}
		else{
			P7.5=0;
		}
		P7.3=1;
		d1=d1 << 1;
		P7.3=0;
	}
	
	for(i=0;i<16;i++){
		if((d0 & 0x8000)==0x8000){
			P7.5=1;
		}
		else{
			P7.5=0;
		}
		P7.3=1;
		d0=d0 << 1;
		P7.3=0;
	}
	P7.4=1;
	P7.5=0;
}

void	vol_out(unsigned int volt)
{
	dac_out_ch1(volt);		/* DAC CH 1 */
}
void	volt_up(void)
{
	out_volt_data++;
	if(out_volt_data>=4096){
		out_volt_data=4095;
	}
}
void	volt_down(void)
{
	if(out_volt_data>0){
		out_volt_data--;
	}
}
void	vol_out_tun(unsigned int volt)
{
	dac_out_ch2(volt);		/* DAC CH 2 */
}



/*----------  KHZ    ----------*/
void	khz_inc(void)
{
	khz_no=khz_no+5;
	if(khz_no==8205){khz_no=3000;}
}

void	khz_dec(void)
{
	khz_no=khz_no-5;
	if(khz_no==2995){khz_no=8200;}
}
void	khz_inc_50(void)
{
	khz_no=khz_no+50;
	if(khz_no>=8205){khz_no=3000;}
}

void	khz_dec_50(void)
{
	khz_no=khz_no-50;
	if(khz_no<=2995){khz_no=8200;}
}


void	khz_set(void)
{
unsigned long data;

	if(khz_no<3500){data=(1032*(unsigned long)khz_no-2693000)/1000;}
	if((khz_no>=3500)&(khz_no<4100)){data=(961*(unsigned long)khz_no-2440000)/1000;}
	if((khz_no>=4100)&(khz_no<4800)){data=(774*(unsigned long)khz_no-1668000)/1000;}
	if((khz_no>=4800)&(khz_no<5800)){data=(596*(unsigned long)khz_no-798000)/1000;}
	if((khz_no>=5800)&(khz_no<7000)){data=(485*(unsigned long)khz_no-153000)/1000;}
	if(khz_no>=7000){data=(424*(unsigned long)khz_no+271000)/1000;}

	out_volt_data=(unsigned int)(data);
}
void	khz_set_tun(void)
{
unsigned int data0;
unsigned long data;

	data=(569*(unsigned long)khz_no-1185000)/1000;

	data0=(unsigned int)(data);
	vol_out_tun(data0);
}


/*----------- DATA INPUT ----------*/
unsigned int freq_count_in(void)
{
unsigned long	freq;

	/*
	freq=f_sokutei*10000;
	freq=freq/98304-455;
	*/
	freq=f_sokutei*10000;
	freq=freq/49152-455;
	
	return (unsigned int)freq;
}

/*---------- PRESET ---------*/
unsigned int preset_khz(unsigned char no)
{
	if(no>=150){no=149;}
	return d[no];
}
void	preset_up(void)
{
	preset_no++;
	if(preset_no>=150){preset_no=0;}
}
void	preset_down(void)
{
	if(preset_no<=0){preset_no=149;}
	else{preset_no--;}
}



/*---------- OUT HZ ----------------*/
void	out_hz_sub(unsigned int hz)
{
unsigned int	i;

	for(i=0;i<16;i++){
		wait_time(10);
		P12.0=0;
		wait_time(10);
		if(hz>=0x8000){
			P12.1=1;
		}
		else{
			P12.1=0;
		}
		hz=hz<<1;
		wait_time(10);
		P12.0=1;
	}
	wait_time(10);
	P12.0=0;
	P12.1=0;
}


void  main( void )
{
unsigned int	freq_khz;
unsigned int	freq_khz_b;
unsigned int	adj;
unsigned int	sub;
unsigned char	up_key;
unsigned char	up_rep;
unsigned char	up_cnt;
unsigned char	down_key;
unsigned char	down_rep;
unsigned char	down_cnt;
unsigned char	set_key;
unsigned char	set_rep;
unsigned char	set_cnt;
unsigned char	menu_key;
unsigned char	menu_rep;
unsigned char	menu_cnt;
unsigned char	ok_led;

	init_data();
	/*preset_set();*/

	up_key=0;up_rep=0;
	down_key=0;down_rep=0;
	set_key=0;set_rep=0;
	menu_key=0;menu_rep=0;
	up_cnt=0;down_cnt=0;
	set_cnt=0;menu_cnt=0;
	preset_no=0;
	sub=0;
	over=0;sokutei=0;
	freq_khz_b=0;
	ok_led=0;

	led_clear();

	adj=0;

	khz_no=3000;

	khz_set();vol_out(out_volt_data);
	khz_set_tun();

	led_khz(khz_no);
	out_hz_sub(khz_no);

	TM50_Start();

	/* Start user code. Do not edit comment generated here */
	while (1) {
	/* key scan 1 */
		if (P1.4==0){
				up_key=0;
		}
		else{
			up_key=1;
			up_rep=0;
			up_cnt=0;
		}
		/*------------------*/
		if (P1.5==0){
				down_key=0;
		}
		else{
			down_key=1;
			down_rep=0;
			down_cnt=0;
		}
		/*------------------*/
		if (P1.6==0){
				set_key=0;
		}
		else{
			set_key=1;
			set_rep=0;
			set_cnt=0;
		}
		/*------------------*/
		if (P1.7==0){
				menu_key=0;
		}
		else{
			menu_key=1;
			menu_rep=0;
			menu_cnt=0;
		}
		/*------------------*/


		/*-------------------*/
		
		if(freq_khz!=freq_khz_b){
			freq_khz_b=freq_khz;
		}
		else{
			wait_time(4000);  /* 2000 */
		}
		
		
		/****
		if(sub==0){
			freq_khz=freq_count_in();
			sub=10;
		}
		else{
			sub--;
		}
		*****/

		if(freq_khz>(khz_no+3)){adj=0;}
		if(freq_khz<(khz_no-3)){adj=0;}
		
		if(adj==0){
		/*---------------------*/
		freq_khz=freq_count_in();
		if(freq_khz==khz_no){
			adj=2000;
			ok_led=1;
		}
		if(freq_khz==(khz_no+1)){
			/*volt_down();
			vol_out(out_volt_data);*/
			adj=200;
			ok_led=1;
		}
		if(freq_khz==(khz_no-1)){
			/*volt_up();
			vol_out(out_volt_data);*/
			adj=200;
			ok_led=1;
		}
		if(freq_khz==(khz_no+2)){
			volt_down();
			vol_out(out_volt_data);
			adj=20;
			ok_led=0;
		}
		if(freq_khz==(khz_no-2)){
			volt_up();
			vol_out(out_volt_data);
			adj=20;
			ok_led=0;
		}
		if(freq_khz==(khz_no+3)){
			volt_down();
			vol_out(out_volt_data);
			adj=10;
			ok_led=0;
		}
		if(freq_khz==(khz_no-3)){
			volt_up();
			vol_out(out_volt_data);
			adj=10;
			ok_led=0;
		}
		if(freq_khz>(khz_no+3)){
			volt_down();
			vol_out(out_volt_data);
			adj=0;
			ok_led=0;
		}
		if(freq_khz<(khz_no-3)){
			volt_up();
			vol_out(out_volt_data);
			adj=0;
			ok_led=0;
		}
		/*-----------------------*/
		}
		else{
			adj--;
		}

		/*-------------------*/

	/* key scan 2 */
		if ((P1.4==0)&(up_key==0)){
			up_key=0;
		}
		else{
			up_key=1;
			up_rep=0;
			up_cnt=0;
		}
		/*------------------*/
		if ((P1.5==0)&(down_key==0)){
			down_key=0;
		}
		else{
			down_key=1;
			down_rep=0;
			down_cnt=0;
		}
		/*------------------*/
		if ((P1.6==0)&(set_key==0)){
			set_key=0;
		}
		else{
			set_key=1;
			set_rep=0;
			set_cnt=0;
		}
		/*------------------*/
		if ((P1.7==0)&(menu_key==0)){
			menu_key=0;
		}
		else{
			menu_key=1;
			menu_rep=0;
			menu_cnt=0;
		}
		/*------------------*/


	/* key action */
	
		if((up_key==0)&(up_rep==0)){
			up_rep=1;
			khz_inc();
			khz_set();
			khz_set_tun();
			led_khz(khz_no);
			out_hz_sub(khz_no);
			adj=0;
			ok_led=0;
		}
		if((up_key==0)&(up_rep==1)){
			up_cnt++;
			if(up_cnt>=200){
				khz_inc_50();
				khz_set();
				khz_set_tun();
				led_khz(khz_no);
				out_hz_sub(khz_no);
				up_cnt=150;
			}
			adj=0;
			ok_led=0;
		}
		/*------------------*/
		if((down_key==0)&(down_rep==0)){
			down_rep=1;
			khz_dec();
			khz_set();
			khz_set_tun();
			led_khz(khz_no);
			out_hz_sub(khz_no);
			adj=0;
			ok_led=0;
		}
		if((down_key==0)&(down_rep==1)){
			down_cnt++;
			if(down_cnt>=200){
				khz_dec_50();
				khz_set();
				khz_set_tun();
				led_khz(khz_no);
				out_hz_sub(khz_no);
				down_cnt=150;
			}
			adj=0;
			ok_led=0;
		}
		/*------------------*/



		/*--------------------*/
		if((set_key==0)&(set_rep==0)){
			set_rep=1;
			preset_up();
			khz_no=preset_khz(preset_no);
			khz_set();
			khz_set_tun();
			led_khz(khz_no);
			out_hz_sub(khz_no);
			adj=0;
			ok_led=0;
		}
		if((set_key==0)&(set_rep==1)){
			set_cnt++;
			if(set_cnt>=250){
				khz_no=6115;
				khz_set();
				khz_set_tun();
				led_khz(khz_no);
				out_hz_sub(khz_no);
				down_cnt=0;
			}
			adj=0;
			ok_led=0;
		}
		/*--------------------*/
		if((menu_key==0)&(menu_rep==0)){
			menu_rep=1;
			preset_down();
			khz_no=preset_khz(preset_no);
			khz_set();
			khz_set_tun();
			led_khz(khz_no);
			out_hz_sub(khz_no);
			adj=0;
			ok_led=0;
		}
		if((menu_key==0)&(menu_rep==1)){
			menu_cnt++;
			if(menu_cnt>=250){
				khz_no=6055;
				khz_set();
				khz_set_tun();
				led_khz(khz_no);
				out_hz_sub(khz_no);
				down_cnt=0;
			}
			adj=0;
			ok_led=0;
		}
		/*------------------*/

		if(led_count>0){
			if(ok_led==0){P3.0=1;}
			else{P3.0=0;}
			led_count--;
			if(led_count==0){
				led_clear();
				ok_led=0;
			}
		}
	}
	/* End user code. Do not edit comment generated here */
}

/* Start adding user code. Do not edit comment generated here */
/* End user code adding. Do not edit comment generated here */


